#include <utility>

void by_value     (int   x) { ++x; }
void by_lvalue_ref(int&  x) { ++x; }
void by_rvalue_ref(int&& x) { ++x; }

static void example()
{
    int number = 3;
    by_value     (number); // copies    ==> number == 3
    by_lvalue_ref(number); // reference ==> number == 4
    //by_rvalue_ref(number); // error

    by_value     (int{7}); // copies    ==> temporary object == 7
    //by_lvalue_ref(int{7}); // error
    by_rvalue_ref(int{7}); // reference ==> temporary object == 8

    by_rvalue_ref(std::move(number)); // reference ==> number == 5
}
